#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "mt19937ar.h"

int main(int argc, char** argv)
{
  int lc = 0, indot = 0;
  int cdot;

  double dot_x, dot_y, dot_norm;
  double q_r1c_area, mcpi;

  if(argc != 2){
    fprintf(stderr, "usage: mcpi <# of dot>\n");
    return EXIT_FAILURE;
  }

  // get # of dot
  cdot = atoi(argv[1]);

  // rand generator initalization
  init_genrand(time(NULL));

  // Monte Carlo method
  for(lc = 0; lc < cdot; lc++){
    // fix coordinates and norm of dot 
    dot_x = genrand_real1();
    dot_y = genrand_real1();
    dot_norm = dot_x * dot_x + dot_y * dot_y;

    // check whether 1/4*r1circle include a dot
    if(dot_norm < 1)
      indot++;

  }

  // culc area of 1/4*r1circle
  q_r1c_area = (double)indot / (double)cdot;

  // culc pi
  mcpi = q_r1c_area * 4;

  printf("PI=%f\n", mcpi);

  return EXIT_SUCCESS;
}
